/* rec_io.h - header for record file I/O functions */
#ifndef REC_IO_H
#define REC_IO_H
#include "local.h"
#include "bin_io.h"

#define REC_NFILE 		BIN_NFILE	/* adjust to local system */
#define REC_NEXT		(-1L)
#define REC_W_END		(-2L)
#define REC_NOT_FOUND	(-3L)	/* codes for hashed file access */
#define REC_FULL		(-4L)	/* codes for hashed file access */
#define REC_ERROR		(-5L)	/* codes for hashed file access */
#define REC_AVAIL		'a'		/* codes for hashed file access */
#define REC_OCCUP		'o'		/* codes for hashed file access */
#define REC_DELET		'd'		/* codes for hashed file access */
#define REC_FILE struct rec_file
REC_FILE
	{
	short _byte0;				/* offset of the first data byte in file */
	short _recsize;				/* size (in bytes) of each record */
	long _nrecs;				/* size (in records) of current file */
	bits _status;				/* open-modes of file */
	};
#define REC_BYTE0 BUFSIZ
#define rec_nrecs(fd)	(rec_files[fd]._nrecs + 0)
#define rec_recsize(fd) (rec_files[fd]._recsize + 0)

typedef int rec_fd;

extern int errno;
extern REC_FILE rec_files[REC_NFILE];

int rec_close();	/* PARMS(rec_fd fd) */
rec_fd rec_open();	/* PARMS(char fname[], int type, int recsize) */
bool rec_get();		/* PARMS(rec_fd fd, data_ptr buf, long i) */
bool rec_put();		/* PARMS(rec_fd fd, data_ptr buf, long i) */
long rec_hfind();
/* PARMS(rec_fd fd, data_ptr keybuf, data_ptr buf, int (*cmp)(), long (*hash)()) */
long rec_havail();
/* PARMS(rec_fd fd, data_ptr keybuf, data_ptr buf, long (*hash)()) */
#endif
